/**************************************************************************
MG811_CO2 library
Copyright (C) Hartley Maker Space - www.ededu.org
Author: Ampear Lee
Email: bd5qdm@gmail.com
Version:1.0
**************************************************************************/
#include <Arduino.h>
#include "Mg811_CO2.h"

int Mg811_CO2::Read(int analogPin, int sampleTimes, int sampleInterval) 
{
  _AnalogPin=analogPin;
  float v=0;
  for (int i=0;i<sampleTimes;i++) 
      {
       v=v+analogRead(_AnalogPin);
	   delay(sampleInterval);
       }
  float volts = (v/sampleTimes) *5/1024 ;
  
  
  if ((volts/8.5 )>=0.324) 
      {
       return -1;
      } 
  else 
      { 
       return pow(10, ((volts/8.5)-0.324)/(0.020/(2.602-3))+2.602);
      }
}








